summaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/distro/build-recipe-list.py117
-rwxr-xr-xscripts/distro/distrocompare.sh123
2 files changed, 240 insertions, 0 deletions
diff --git a/scripts/distro/build-recipe-list.py b/scripts/distro/build-recipe-list.py
new file mode 100755
index 0000000000..407debaa76
--- /dev/null
+++ b/scripts/distro/build-recipe-list.py
@@ -0,0 +1,117 @@
1#!/usr/bin/env python3
2#
3# Copyright (c) 2017, Intel Corporation.
4#
5# This program is free software; you can redistribute it and/or modify it
6# under the terms and conditions of the GNU General Public License,
7# version 2, as published by the Free Software Foundation.
8#
9# This program is distributed in the hope it will be useful, but WITHOUT
10# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
11# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
12# more details.
13#
14
15import os
16import shutil
17import csv
18import sys
19import argparse
20
21__version__ = "0.1.0"
22
23recipenames = []
24allrecipes = []
25
26def gather_recipes(rows):
27 # store the data into the array
28 for row in rows:
29 if row[0] not in recipenames:
30 recipenames.append(row[0])
31 allrecipes.append(row)
32
33def generate_recipe_list():
34 # machine list
35 machine_list = ( "qemuarm64", "qemuarm", "qemumips64", "qemumips", "qemuppc", "qemux86-64", "qemux86" )
36 # set filename format
37 fnformat = 'distrodata.%s.csv'
38
39 # store all data files in distrodata
40 datadir = 'distrodata'
41
42 # create the directory if it does not exists
43 if not os.path.exists(datadir):
44 os.mkdir(datadir)
45
46 # doing bitbake distrodata
47 for machine in machine_list:
48 os.system('MACHINE='+ machine + ' bitbake world -c distrodata')
49 shutil.copy('tmp/log/distrodata.csv', 'distrodata/' + fnformat % machine)
50
51 for machine in machine_list:
52 with open('distrodata/' + fnformat % machine) as f:
53 reader = csv.reader(f)
54 rows = reader.__iter__()
55 gather_recipes(rows)
56
57 with open('recipe-list.txt', 'w') as f:
58 for recipe in sorted(recipenames):
59 f.write("%s\n" % recipe)
60 print("file : recipe-list.txt is created with %d entries." % len(recipenames))
61
62 with open('all-recipe-list.txt', 'w') as f:
63 for recipe in sorted(allrecipes):
64 f.write("%s\n" % ','.join([str(data) for data in recipe]))
65
66
67def diff_for_new_recipes(recipe1, recipe2):
68 prev_recipe_path = recipe1 + '/'
69 curr_recipe_path = recipe2 + '/'
70 if not os.path.isfile(prev_recipe_path + 'recipe-list.txt') or not os.path.isfile(curr_recipe_path + 'recipe-list.txt'):
71 print("recipe files do not exists. please verify that the file exists.")
72 exit(1)
73
74 import csv
75
76 prev = []
77 new = []
78
79 with open(prev_recipe_path + 'recipe-list.txt') as f:
80 prev = f.readlines()
81
82 with open(curr_recipe_path + 'recipe-list.txt') as f:
83 new = f.readlines()
84
85 updates = []
86 for pn in new:
87 if not pn in prev:
88 updates.append(pn.rstrip())
89
90 allrecipe = []
91 with open(recipe1 + '_' + recipe2 + '_new_recipe_list.txt','w') as dr:
92 with open(curr_recipe_path + 'all-recipe-list.txt') as f:
93 reader = csv.reader(f, delimiter=',')
94 for row in reader:
95 if row[0] in updates:
96 dr.write("%s,%s,%s" % (row[0], row[3], row[5]))
97 if len(row[9:]) > 0:
98 dr.write(",%s" % ','.join(row[9:]))
99 dr.write("\n")
100
101def main(argv):
102 if argv[0] == "generate_recipe_list":
103 generate_recipe_list()
104 elif argv[0] == "compare_recipe":
105 diff_for_new_recipes(argv[1], argv[2])
106 else:
107 print("no such option. choose either 'generate_recipe_list' or 'compare_recipe'")
108
109 exit(0)
110
111if __name__ == "__main__":
112 try:
113 sys.exit(main(sys.argv[1:]))
114 except Exception as e:
115 print("Exception :", e)
116 sys.exit(1)
117
diff --git a/scripts/distro/distrocompare.sh b/scripts/distro/distrocompare.sh
new file mode 100755
index 0000000000..908760c235
--- /dev/null
+++ b/scripts/distro/distrocompare.sh
@@ -0,0 +1,123 @@
1#!/usr/bin/env bash
2#
3# Copyright (c) 2017, Intel Corporation.
4# All rights reserved.
5#
6# This program is free software; you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation; either version 2 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program; if not, write to the Free Software
18# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
19#
20# distrocompare.sh : provides capability to get a list of new packages
21# based on two distinct branches. This script takes
22# 2 parameters; either a commit-ish or a branch name
23#
24# To run : distrocompare.sh <older hash> <newer hash>
25# E.g. distrocompare.sh morty 92aa0e7
26# E.g. distrocompare.sh morty pyro
27#
28
29# get input as version
30previous_version=$1
31current_version=$2
32
33# set previous and current version
34if [ -z "$2" ]; then
35 previous_version=$1
36 current_version="current"
37fi
38
39# get script location. That's where the source supposedly located as well.
40scriptdir="$( realpath $(dirname "${BASH_SOURCE[0]}" ))"
41sourcedir="$( realpath $scriptdir/../.. )"
42
43# create working directory
44workdir=$(mktemp -d)
45
46# prepare to rollback to the branch if not similar
47branch=`cd $sourcedir; git branch | grep \* | cut -d ' ' -f2`
48
49# set current workdir to store final result
50currentworkdir=`pwd`
51
52# persists the file after local repo change
53cp $scriptdir/build-recipe-list.py $workdir
54
55#==================================================================
56
57function bake_distrodata {
58 # get to source directory of the git
59 cd $sourcedir
60
61 # change the branch / commit. Do not change if input is current
62 if [ "$1" != "current" ]; then
63 output=$(git checkout $1 2>&1)
64
65 # exit if git fails
66 if [[ $output == *"error"* ]]; then
67 echo "git error : $output"
68 echo "exiting ... "
69 rm -rf $workdir
70 exit
71 fi
72 fi
73
74 # make tmp as workdir
75 cd $workdir
76
77 # source oe-init to generate a new build folder
78 source $sourcedir/oe-init-build-env $1
79
80 # if file already exists with distrodata, do not append
81 if ! grep -q "distrodata" "conf/local.conf"; then
82 # add inherit distrodata to local.conf to enable distrodata feature
83 echo 'INHERIT += "distrodata"' >> conf/local.conf
84 fi
85
86 # use from tmp
87 $workdir/build-recipe-list.py generate_recipe_list
88}
89
90bake_distrodata $previous_version
91bake_distrodata $current_version
92
93#==================================================================
94
95cd $workdir
96
97# compare the 2 generated recipe-list.txt
98$workdir/build-recipe-list.py compare_recipe $previous_version $current_version
99
100# copy final result to current working directory
101cp $workdir/*_new_recipe_list.txt $currentworkdir
102
103if [ $? -ne 0 ]; then
104 rm -rf $workdir/$previous_version
105 rm -rf $workdir/$current_version
106 rm $workdir/build-recipe-list.py
107 # preserve the result in /tmp/distrodata if fail to copy the result over
108 exit
109fi
110
111# cleanup
112rm -rf $workdir
113
114# perform rollback branch
115cd $sourcedir
116currentbranch=`git branch | grep \* | cut -d ' ' -f2`
117if [ "$currentbranch" != "$branch" ]; then
118 git checkout $branch
119fi
120
121cd $currentworkdir
122
123#==================================================================